/*****************************************************************************

   This file is part of Virtual VCS, the Atari 2600 Emulator
   ===================================================

   Copyright 1996 Alex Hornby. For contributions see the file CREDITS.
   Modified 1996 by Daniel Boris

   This software is distributed under the terms of the GNU General Public
   License. This is free software with ABSOLUTELY NO WARRANTY.

   See the file COPYING for Details.

   $Id: display.c,v 1.23 1996/03/21 15:52:38 alex Exp $
******************************************************************************/

/*
   Display handling code.
*/

#include <stdio.h>
#include <stdlib.h>

#include "sega_scl2.h"
#include "types.h"
#include "colours.h"

#define	RGB( r, g, b )		(0x8000U|((b) << 10)|((g) << 5 )|(r))

char coltable[256];

/* Set up the colormap */
void create_cmap(void)
{
	int i;
	BYTE red,green,blue;
	/*unsigned short rgb;*/
	unsigned short palette[256];

	for(i=0; i< 256; i++)
	{
		red  = (BYTE)((colortable[i] & 0xff0000) >> 19);
		green = (BYTE)((colortable[i] & 0x00ff00) >> 11);
		blue = (BYTE)((colortable[i] & 0x0000ff) >> 3);
		palette[i]=RGB( red, green, blue);
	}
	SCL_SetColRam(SCL_NBG0,0,256,palette);
	SCL_SetColRam(SCL_NBG1,0,256,palette);
}

/* Create the main application shell */
static void create_window()
{
	int i;
	//vwidth=tv_width<<1;
	//vheight=tv_height+tv_overscan;
	create_cmap();
	for(i=0; i<256; i++) coltable[i]=1;
	coltable[0]=coltable[1]=coltable[2]=coltable[4]=0;
	coltable[8]=coltable[16]=coltable[32]=coltable[64]=0;
	coltable[128]=0;
}

/* The main initialiser for the X stuff */
int tv_on()
{
	create_window();
	return(1);
}
