/*****************************************************************************

   This file is part of Virtual VCS, the Atari 2600 Emulator
   ===================================================

   Copyright 1996 Daniel Boris. For contributions see the file CREDITS.

   This software is distributed under the terms of the GNU General Public
   License. This is free software with ABSOLUTELY NO WARRANTY.

   See the file COPYING for Details.

******************************************************************************/

/*
   Used to load cartridge images into memory.
   This module has been completely re-written since X2600
*/

#include <stdio.h>
#include <string.h>
#include "types.h"
#include "vmachine.h"
#include "config.h"
#include "resource.h"

#include "sega_scl2.h"

/*#include "pacman.h"*/
/*#include "pitfall.h"*/
/*#include "berzerk.h"*/
/*#include "invaders.h"*/
/*#include "carnival.h"*/
/*#include "treat.h"*/

#define MD5 1

#ifdef MD5
#include "md5.h"

//#include "gpdef.h"
//#include "gpstdlib.h"
//#include "gpgraphic.h"

//extern GPDRAWSURFACE gpDraw[2]; /*the main screen, well 2, for a double buffer*/

typedef struct {
	char md5[33];
	char type[5];
} cartliststruct;

#include "cartlist.h"
#endif 

//extern char VCSbasedir[];
extern char cart_loaded;



int loadNewCart( char *name) {
	char fullname[256];
	long len, i, checksum, file_id;
	//F_HANDLE cartfile;
	unsigned long readtotal;
	char md5val[33];

//	strcpy(fullname, VCSbasedir);
//	strcat(fullname, "\\");
//	strcat(fullname, name);

char toto[50];

	file_id = GFS_NameToId(name);
        //GpFileGetSize(fullname, &len);
	len = GetFileSize(file_id);
	//GpFileOpen(fullname, OPEN_R, &cartfile);
	//GpFileRead(cartfile, &cart[0], len, &readtotal);
/*
	sprintf(toto,"FILE %d %d",file_id,len);
#define	RGB( r, g, b )		(0x8000U|((b) << 10)|((g) << 5 )|(r))
	unsigned short palette[8]=
	{
	RGB( 164>>3, 181>>3, 197>>3),RGB( 0,0,0 ),RGB( 164>>3, 181>>3, 197>>3),RGB( 214>>3, 230>>3, 247>>3 ),
	RGB( 164>>3, 181>>3, 197>>3),RGB( 0,0,0 ),RGB( 164>>3, 181>>3, 197>>3),RGB( 214>>3, 230>>3, 247>>3 ),
	};
	SCL_SetColRam(SCL_NBG1,0,8,palette);
	SCL_SetColRam(SCL_NBG0,0,8,palette);
		FNT_Print256_2bpp((volatile Uint8 *)SCL_VDP2_VRAM_A1,
						(Uint8 *)toto,10,42);
*/
     GFS_Load(file_id, 0, &cart[0], len);
//		FNT_Print256_2bpp((volatile Uint8 *)SCL_VDP2_VRAM_A1,
//						(Uint8 *)toto,10,34);
	//GpFileClose(cartfile);
	/*len=4096;*/

	/* Default values */
	app_data.bank=2;
	app_data.sc=0;

	checksum=0;
	for(i=0; i<len; i++) checksum+=cart[i];
	/*printf("Checksum: %lx\n",checksum);*/
	/*show_config();*/
	
	/* Calc MD5 for the cart */
#ifdef MD5
	MD5calc(cart, len, md5val);
	md5val[32] = 0;
	/*
	sprintf(toto,"checksum %lx len %d",md5val,len);
FNT_Print256_2bpp((volatile Uint8 *)SCL_VDP2_VRAM_A1,
						(Uint8 *)toto,10,62);
  */
	/* Look up for the MD5 in the cart database */
	i=0;
	/*strcpy(cartlist[10].md5, "3e90cf23106f2e08b2781e41299de556");*/
	while ((i<CARTCOUNT) && strcmp(md5val, cartlist[i].md5)) i++;

	/*
	GpTextOut(NULL, &gpDraw[0].ptbuffer, 0, 150, md5val, 10);
	GpTextOut(NULL, &gpDraw[1].ptbuffer, 0, 150, md5val, 10);
	GpTextOut(NULL, &gpDraw[0].ptbuffer, 0, 160, cartlist[i].name, 10);
	GpTextOut(NULL, &gpDraw[1].ptbuffer, 0, 160, cartlist[i].name, 10);
	while(1) {};
	sprintf(fullname, "Len: %d", len);
	GpTextOut(NULL, &gpDraw[0].ptbuffer, 0, 160, fullname, 10);
	GpTextOut(NULL, &gpDraw[1].ptbuffer, 0, 160, fullname, 10);
	while(1) {};
	*/

	if (i == CARTCOUNT)	{
//		FNT_Print256_2bpp((volatile Uint8 *)SCL_VDP2_VRAM_A1,
//				(Uint8 *)"DEFAULT MAPPING",90,12);
		/* Not found */
	} else {

//				FNT_Print256_2bpp((volatile Uint8 *)SCL_VDP2_VRAM_A1,
//						(Uint8 *)"CUSTOM MAPPING ",90,12);
		/* Found */
		if (!strcmp(cartlist[i].type,"2K")) app_data.bank=0;
		if (!strcmp(cartlist[i].type,"4K")) app_data.bank=0;
		if (!strcmp(cartlist[i].type,"F6")) app_data.bank=1;
		if (!strcmp(cartlist[i].type,"F8")) app_data.bank=2;
		if (!strcmp(cartlist[i].type,"E0")) app_data.bank=4;
		if (!strcmp(cartlist[i].type,"FA")) app_data.bank=3;
		if (!strcmp(cartlist[i].type,"F6SC")) {
			app_data.bank=1;
			app_data.sc=1;
		}

/*		GpTextOut(NULL, &gpDraw[0].ptbuffer, 0, 150, sprintf("Type: %s", cartlist[i].type), 10);
		GpTextOut(NULL, &gpDraw[1].ptbuffer, 0, 150, sprintf("Type: %s", cartlist[i].type), 10);*/
/*		GpTextOut(NULL, &gpDraw[0].ptbuffer, 0, 150, cartlist[i].type, 10);
		GpTextOut(NULL, &gpDraw[1].ptbuffer, 0, 150, cartlist[i].type, 10);*/
	}
#endif
	switch (app_data.bank) {
	case 0:
	case 1:
	case 2:
		switch (len) {
			case 2048:
 // VBT a faire plus tard
				//memcpy(&theRom[0],&cart[0],2048);
				//memcpy(&theRom[2048],&cart[0],2048);
				theRom=&cart[0];
				break;
			case 4096:
//				memcpy(&theRom[0],&cart[0],4096);
				theRom=&cart[0];
				break;
			case 8192:
				//memcpy(&theRom[0],&cart[4096],4096);
				theRom=&cart[4096];
				break;
			case 16384:
				//memcpy(&theRom[0],&cart[12288],4096);
				theRom=&cart[12288];
				break;
		}
		break;
	case 3:
		//memcpy(theRom[0],&cart[8192],4096);
		theRom=&cart[8192];
		break;
	case 4:
 // VBT a faire plus tard
		//memcpy(&theRom[0],&cart[0],3072);
		//memcpy(&theRom[0xC00],&cart[0x1C00],1024);
			theRom=&cart[0];
		break;
	}
	/*mainloop_init();*/
	cart_loaded = 1;
	return 0;

}
