
/*****************************************************************************

   This file is part of Virtual VCS, the Atari 2600 Emulator
   ===================================================

   Copyright 1996 Alex Hornby. For contributions see the file CREDITS.
   Modified 1996 by Daniel Boris

   This software is distributed under the terms of the GNU General Public
   License. This is free software with ABSOLUTELY NO WARRANTY.

   See the file COPYING for Details.

******************************************************************************/

/*
 * Holds the memory access routines to both memory and memory mapped
 * i/o, hence memory.c
 *
*/

#include <stdio.h>
#include "types.h"
#include "address.h"
#include "vmachine.h"
#include "misc.h"
#include "display.h"
#include "raster.h"
#include "collisio.h"
#include "resource.h"
#include "sega_scl2.h"

//extern unsigned char picture[512*192];

extern CLOCK clkcount;
extern CLOCK clk;
//extern int ebeamadj;
extern int beamadj;
extern BYTE keypad[8];
int vbt=0;
//int 10/08/08;
//extern int ExKey;
extern unsigned short frames_count; /* FPS Counter */
/* The refresh skipping counter */
int tv_counter=0;

/* UnDecoded Read */
/*__inline__*/ BYTE undecRead (ADDRESS a) {
	if(a & 0x1000)
		return theRom[a & 0xfff];
	//else
		return theRam[a & 0x7f];
}

/* Decoded write */
__inline__ void decWrite ( ADDRESS a, BYTE b) {

	unsigned int i;

	ADDRESS a1;
   // VBT a remettre
	if (a & 0x1000) {

		a=a & 0xfff;
		if (app_data.bank == 3) {
			if (a < 0x100) cartram[a]=b;
		}

		if (app_data.sc) {
			if (a < 0x7f) cartram[a] = b;
		}
		switch (app_data.bank) {
			case 1:
				if (a == 0xff6) theRom=&cart[0];//memcpy(&theRom[0],&cart[0],4096);
				if (a == 0xff7) theRom=&cart[4096];//memcpy(&theRom[0],&cart[4096],4096);
				if (a == 0xff8) theRom=&cart[8192];//memcpyl(&theRom[0],&cart[8192],4096);
				if (a == 0xff9) theRom=&cart[12288];//memcpyl(&theRom[0],&cart[12288],4096);
				break;
			case 2:
				//if (a == 0xff8) memcpy(&theRom[0],&cart[0],4096);
				//if (a == 0xff9) memcpy(&theRom[0],&cart[4096],4096);
				if (a & 1) theRom=&cart[4096];//memcpy(&theRom[0],&cart[4096],4096);
				else       theRom=&cart[0];//memcpy(&theRom[0],&cart[0],4096);
				break;
			case 3:
				if (a == 0xff8) theRom=&cart[0];//memcpy(&theRom[0],&cart[0],4096);
				if (a == 0xff9) theRom=&cart[4096];//memcpy(&theRom[0],&cart[4096],4096);
				if (a == 0xffa) theRom=&cart[8192];//memcpy(&theRom[0],&cart[8192],4096);
				break;

			case 4:
				if (a > 0xfdf && a < 0xfe8) {
					a1=(a&0x07)<<10;
					theRom=&cart[a1];//memcpy(&theRom[0],&cart[a1],0x400);
				}
				if (a > 0xfe7 && a < 0xff0) {
					a1=(a&0x07)<<10;
					memcpyl(&theRom[0x400],&cart[a1],0x400);
				}
				if (a > 0xfef && a < 0xff8) {
					a1=(a&0x07)<<10;
					memcpyl(&theRom[0x800],&cart[a1],0x400);
				}
				break;

		}
		return;
	}
 
	/* RAM, mapped to page 0 and 1*/
	
	if ((a & 0x280) == 0x80) {
		theRam[a & 0x7f]=b;
		return;
	}
	 
	//ebeamadj = ebeamx + beamadj;

	if (!(a & 0x80)) {
	switch(a & 0x7f){
	/* TIA */
	case VSYNC:
	if(b & 0x02) {
		/* Start vertical sync */
		vbeam_state=VSYNCSTATE;
		frames_count++;	
		tv_counter++;
	}
	break;
	case VBLANK:
		if(b & 0x02) {
		if (!(tiaWrite[VBLANK] & 0x02)) {
			/* Start vertical blank */
			vbeam_state=VBLANKSTATE;
			/* Also means we can update screen */
			/* Insert vysnc stuff here */
			/* display.c - copies from vbuffer to screen */
			//tv_counter++;
			//frames_count++;	
		}
	}
		else {
			/* End vblank, and start first hsync drawing */
			vbeam_state=DRAWSTATE;
			hbeam_state=HSYNCSTATE;
			/* Set up the screen */
			for( i=0; i<unified_count; i++) use_unified_change(&unified[i]);
				/* Hope for a WSYNC, but just in case */
				ebeamx=-TV_HSYNC;
				ebeamy=0;
		}
		/* Logic for dumped input ports */
		if(b & 0x40){
			/*Enable latches*/
			tiaRead[INPT4]=0x80;
			tiaRead[INPT5]=0x80;
		}
		if(b & 0x80) {
			tiaRead[INPT0]=0x00;
			//paddle1.val=0;
		}
		tiaWrite[VBLANK]=b;

		break;
	case WSYNC:
	/* SKIP to HSYNC pulse */
	if( vbeam_state==DRAWSTATE && (ebeamx > -TV_HSYNC)) {
		tv_raster(ebeamy);
		/* Fix the clock value */
		clk+=(ebeamx-TV_WIDTH)/3;
		ebeamy++;
	}
		hbeam_state=HSYNCSTATE;
		ebeamx=-TV_HSYNC;
		//sbeamx=0;
		break;

	case RSYNC:
		break;
	case NUSIZ0:
		pl[0].nusize= b & 0x07;
		ml[0].width= (b & 0x30) >> 4;
		break;
	case NUSIZ1:
		pl[1].nusize= b & 0x07;
		ml[1].width= (b & 0x30) >> 4;
		break;
	case COLUP0:
		//do_unified_change( 0, b);
	unified[unified_count].x=ebeamx+beamadj;//ebeamadj;//
	unified[unified_count].type=0;
	unified[unified_count].val=b;
	unified_count++;
		break;
	case COLUP1:
//		do_unified_change( 1, b);
	unified[unified_count].x=ebeamx+beamadj;//ebeamadj;//
	unified[unified_count].type=1;
	unified[unified_count].val=b;
	unified_count++;
		break;
	case COLUPF:
//		do_unified_change( 2, b);
	unified[unified_count].x=ebeamx+beamadj;//ebeamadj;//
	unified[unified_count].type=2;
	unified[unified_count].val=b;
	unified_count++;
		break;
	case COLUBK:
//		do_unified_change( 3, b);
	unified[unified_count].x=ebeamx+beamadj;//ebeamadj;//
	unified[unified_count].type=3;
	unified[unified_count].val=b;
	unified_count++;
		break;

	case CTRLPF:
		tiaWrite[CTRLPF]=b & 0x37; /* Bitmask 00110111 */
		do_pfraster_change(3,b & 0x01); /* Reflection */
		break;
	case REFP0:
		pl[0].reflect=(b &  0x08) >>3;
		break;
	case REFP1:
		pl[1].reflect=(b &  0x08) >>3;
		break;
	case PF0:
		do_pfraster_change(0,b & 0xf0);
		break;
	case PF1:
		do_pfraster_change(1,b);
		break;
	case PF2:
		do_pfraster_change(2,b);
		break;
	case RESP0:
		/* Ghost in pacman! */
		pl[0].x=ebeamx + beamadj;//ebeamadj;//
		if (pl[0].x > 160) pl[0].x=160;
		break;
	case RESP1:
		pl[1].x=ebeamx + beamadj;//ebeamadj;//
		if (pl[1].x > 160) pl[1].x=160;
		break;
	case RESM0:
		ml[0].x=ebeamx + beamadj;//ebeamadj;//
		if (ml[0].x > 160) ml[0].x=160;
		break;
	case RESM1:
		ml[1].x=ebeamx + beamadj;//ebeamadj;//
		if (ml[1].x > 160) ml[1].x=160;
		break;
	case RESBL:
		ml[2].x=ebeamx + beamadj;//ebeamadj;//
		if (ml[2].x > 160) ml[2].x=160;
		break;
	case GRP0:
		do_plraster_change( 0, 0, b);
		do_plraster_change( 1, 1, b);
		break;
	case GRP1:
		do_plraster_change( 1, 0, b);
		do_plraster_change( 0, 1, b);
		ml[2].vdel = ml[2].enabled;
		break;
	case ENAM0:
		ml[0].enabled= b & 0x02;
		if (tiaWrite[RESMP0]) ml[0].enabled=0;
		break;
	case ENAM1:
		ml[1].enabled= b & 0x02;
		if (tiaWrite[RESMP1]) ml[1].enabled=0;
		break;
	case ENABL:
		ml[2].enabled= b & 0x02;
		break;
	case HMP0:
		pl[0].hmm=(b >> 4);
		break;
	case HMP1:
		pl[1].hmm=(b >> 4);
		break;
	case HMM0:
		ml[0].hmm=(b >> 4);
		break;
	case HMM1:
		ml[1].hmm=(b >> 4);
		break;
	case HMBL:
		ml[2].hmm=(b >> 4);
		break;
	case VDELP0:
		pl[0].vdel_flag=b & 0x01;
		break;
	case VDELP1:
		pl[1].vdel_flag=b & 0x01;
		break;
	case VDELBL:
		ml[2].vdel_flag=b & 0x01;
		break;
	case RESMP0:
		tiaWrite[RESMP0]=b & 0x02;
		if (b & 0x02) {
			ml[0].x=pl[0].x+4;
			ml[0].enabled=0;
			if (ml[0].x > 160) ml[0].x=160;
		}
		break;
	case RESMP1:
		tiaWrite[RESMP1]=b & 0x02;
		if (b & 0x02) {
			ml[1].x=pl[1].x+4;
			ml[1].enabled=0;
			if (ml[1].x > 160) ml[1].x=160;
		}
		break;
	case HMOVE:
		if(pl[0].hmm & 0x08)
			pl[0].x+= ((pl[0].hmm ^ 0x0f) +1);
		else
			pl[0].x-=pl[0].hmm;
		if (pl[0].x > 160) pl[0].x=-68;
		if (pl[0].x < -68) pl[0].x=160;

		if(pl[1].hmm & 0x08)
			pl[1].x+= ((pl[1].hmm ^ 0x0f) +1);
		else
			pl[1].x-=pl[1].hmm;
		if (pl[1].x > 160) pl[1].x=-68;
		if (pl[1].x < -68) pl[1].x=160;

		for(i=0; i<3; i++){
			if(ml[i].hmm & 0x08)
				ml[i].x+= ((ml[i].hmm ^ 0x0f)+1);
			else
				ml[i].x-=ml[i].hmm;
			if (ml[i].x > 160) ml[i].x=-68;
			if (ml[i].x < -68) ml[i].x=160;
		}

		break;
	case HMCLR:
		pl[0].hmm=0;
		pl[1].hmm=0;
		//for(i=0;i<3;i++)
		//	ml[i].hmm=0;
			ml[0].hmm=0;
			ml[1].hmm=0;
			ml[2].hmm=0;
		break;
	case CXCLR:
		//reset_collisions();
		memset(tiaRead,0x00,INPT0);
		break;
	case AUDC0:
	case AUDC1:
	case AUDV0:
	case AUDV1:
	case AUDF0:
	case AUDF1:
// VBT !!!            
		//Update_tia_sound(a, b);
		break;
   }
   }
   else
   {
   switch(a & 0x2ff) {
		/* RIOT I/O ports */
		case SWCHA:
			riotWrite[SWCHA]=b;
			break;
		case SWACNT:
			riotWrite[SWACNT]=b;
			break;
		case SWBCNT:
			break;

		/* Timer ports */
		case TIM1T:
			set_timer( 0, b, clkcount);
			break;
		case TIM8T:
			set_timer( 3, b, clkcount);
			break;
		case TIM64T:
			set_timer( 6, b, clkcount);
			break;
		case T1024T:
			set_timer( 10, b, clkcount);
			break;
		}
	}
}


/* Decoded Read */
__inline__ BYTE decRead (ADDRESS a)
{
	BYTE res;
	ADDRESS a1;
	int x;

	/*ExKey = GpKeyGet();*/

	if (a & 0x1000) {
		
		a=a & 0xfff;
		//res=theRom[a & 0xfff];
		//res=theRom[a];
		if (app_data.sc) {
			if (a > 0x7f && a < 0x100) {
				return cartram[a & 0x7f];
				//return res;
			}
		}
		if (app_data.bank == 3) {
			if (a > 0xFF && a < 0x200) {
				return cartram[a & 0xFF];
				//return res;
			}
		}

		//a&= 0xfff;
		//res=theRom[a];

		if (app_data.bank == 0) return theRom[a];
		//a=a & 0xfff;

		switch (app_data.bank) {
			case 1:
//				if (a == 0xff6) memcpy(&theRom[0],&cart[0],4096);
//				if (a == 0xff7) memcpy(&theRom[0],&cart[4096],4096);
//				if (a == 0xff8) memcpy(&theRom[0],&cart[8192],4096);
//				if (a == 0xff9) memcpy(&theRom[0],&cart[12288],4096);
				if (a == 0xff6) theRom=&cart[0];
				if (a == 0xff7) theRom=&cart[4096];
				if (a == 0xff8) theRom=&cart[8192];
				if (a == 0xff9) theRom=&cart[12288];

				break;
			case 2:
//				if (a == 0xff8) memcpy(&theRom[0],&cart[0],4096);
//				if (a == 0xff9) memcpy(&theRom[0],&cart[4096],4096);
				if (a == 0xff8) theRom=&cart[0];
				if (a == 0xff9) theRom=&cart[4096];
				break;
			case 3:
				if (a == 0xff8) theRom=&cart[0];
				if (a == 0xff9) theRom=&cart[4096];
				if (a == 0xffa) theRom=&cart[8192];
				break;

			case 4:
								  // vbt  faire plus tard
				if (a > 0xfdf && a < 0xfe8) {
					a1=(a&0x07)<<10;
					//memcpy(&theRom[0],&cart[a1],0x400);
					theRom=&cart[a1];
				}
				
				if (a > 0xfe7 && a < 0xff0) {
					a1=(a&0x07)<<10;
					memcpy(&theRom[0x400],&cart[a1],0x400);
				}
				if (a > 0xfef && a < 0xff8) {
					a1=(a&0x07)<<10;
					memcpy(&theRom[0x800],&cart[a1],0x400);
				}				 
				
				break;
		}
		return theRom[a];
	}

	if ((a & 0x280) == 0x80) {
		//res = theRam[a & 0x7f];
		//return res;
		return theRam[a & 0x7f];
	}

	if (!(a & 0x80)) {
		switch(a & 0x0f){
		/* TIA */
		case CXM0P:
			return tiaRead[CXM0P];
		case CXM1P:
			return tiaRead[CXM1P];
		case CXP0FB:
			return tiaRead[CXP0FB];
		case CXP1FB:
			return tiaRead[CXP1FB];
		case CXM0FB:
			return tiaRead[CXM0FB];
		case CXM1FB:
			return tiaRead[CXM1FB];
		case CXBLPF:
			return tiaRead[CXBLPF];
		case CXPPMM:
			return tiaRead[CXPPMM];
		case INPT0:	  /*
			if (app_data.left == KEYPAD) {
// VBT !!!                            
				keyboard_keypad();
				tiaRead[INPT0]=0x80;
				if (!(riotWrite[SWCHA] & 0x10)) tiaRead[INPT0]=(keypad[4] & 0x01) << 7;
				if (!(riotWrite[SWCHA] & 0x20)) tiaRead[INPT0]=(keypad[5] & 0x01) << 7;
				if (!(riotWrite[SWCHA] & 0x40)) tiaRead[INPT0]=(keypad[6] & 0x01) << 7;
				if (!(riotWrite[SWCHA] & 0x80)) tiaRead[INPT0]=(keypad[7] & 0x01) << 7;
			}	  */
			return tiaRead[INPT0];
		case INPT1:	   /*
			if (app_data.left == KEYPAD) {
// VBT !!!                            
				keyboard_keypad();
				tiaRead[INPT1]=0x80;
				if (!(riotWrite[SWCHA] & 0x10)) tiaRead[INPT1]=(keypad[4] & 0x02) << 6;
				if (!(riotWrite[SWCHA] & 0x20)) tiaRead[INPT1]=(keypad[5] & 0x02) << 6;
				if (!(riotWrite[SWCHA] & 0x40)) tiaRead[INPT1]=(keypad[6] & 0x02) << 6;
				if (!(riotWrite[SWCHA] & 0x80)) tiaRead[INPT1]=(keypad[7] & 0x02) << 6;
			}		 */
			return tiaRead[INPT1];
			break;
		case INPT2:/*
			if (app_data.right == KEYPAD) {
// VBT !!!                            
				keyboard_keypad();
				tiaRead[INPT2]=0x80;
				if (!(riotWrite[SWCHA] & 0x01)) tiaRead[INPT2]=((keypad[0] & 0x01) << 7);
				if (!(riotWrite[SWCHA] & 0x02)) tiaRead[INPT2]=((keypad[1] & 0x01) << 7);
				if (!(riotWrite[SWCHA] & 0x04)) tiaRead[INPT2]=((keypad[2] & 0x01) << 7);
				if (!(riotWrite[SWCHA] & 0x08)) tiaRead[INPT2]=((keypad[3] & 0x01) << 7);
			}		 */
			return tiaRead[INPT2];
		case INPT3:/*
			if (app_data.right == KEYPAD) {
// VBT !!!                            
				keyboard_keypad();
				tiaRead[INPT3]=0x80;
				if (!(riotWrite[SWCHA] & 0x01)) tiaRead[INPT3]=((keypad[0] & 0x02) << 6);
				if (!(riotWrite[SWCHA] & 0x02)) tiaRead[INPT3]=((keypad[1] & 0x02) << 6);
				if (!(riotWrite[SWCHA] & 0x04)) tiaRead[INPT3]=((keypad[2] & 0x02) << 6);
				if (!(riotWrite[SWCHA] & 0x08)) tiaRead[INPT3]=((keypad[3] & 0x02) << 6);

			}				 */
			return tiaRead[INPT3];
		case INPT4:/*
			if (app_data.left == KEYPAD) {
// VBT !!!                            
				keyboard_keypad();
				tiaRead[INPT4]=0x80;
				if (!(riotWrite[SWCHA] & 0x10)) tiaRead[INPT4]=(keypad[4] & 0x04) << 5;
				if (!(riotWrite[SWCHA] & 0x20)) tiaRead[INPT4]=(keypad[5] & 0x04) << 5;
				if (!(riotWrite[SWCHA] & 0x40)) tiaRead[INPT4]=(keypad[6] & 0x04) << 5;
				if (!(riotWrite[SWCHA] & 0x80)) tiaRead[INPT4]=(keypad[7] & 0x04) << 5;
			}
			else
			{			*/
// VBT !!!                            
				keytrig();
			//}
			return tiaRead[INPT4];
		case INPT5:/*
			if (app_data.right == KEYPAD) {
// VBT !!!                            
				keyboard_keypad();
				tiaRead[INPT5]=0x80;
				if (!(riotWrite[SWCHA] & 0x01)) tiaRead[INPT5]=((keypad[0] & 0x04) << 5);
				if (!(riotWrite[SWCHA] & 0x02)) tiaRead[INPT5]=((keypad[1] & 0x04) << 5);
				if (!(riotWrite[SWCHA] & 0x04)) tiaRead[INPT5]=((keypad[2] & 0x04) << 5);
				if (!(riotWrite[SWCHA] & 0x08)) tiaRead[INPT5]=((keypad[3] & 0x04) << 5);

			}
			else
			{		*/
// VBT !!!                            
				keytrig();
			//}
			return tiaRead[INPT5];
		case 0x0f:
			return 0x0f;
		}
	 }
	 else
	 {
		switch(a & 0x2ff) {
			/* Timer output */
			case INTIM:
			case 0x285:
			case 0x29D:
				return do_timer(clkcount);
			case SWCHA:
				/*
				if (app_data.left == PADDLE) {
// VBT !!!                                    
//					x=mouse_button();
					x=0;
					if (x)
						riotRead[SWCHA] &= 0x7F;
					else
						riotRead[SWCHA] |= 0x80;
				}
				else
				{	   */
// VBT !!!                                    
					keyjoy();	/* Read movements (in keyboard.c) */
				//}
				return riotRead[SWCHA];

			/* Switch B is hardwired to input */
			case SWCHB:
// VBT !!!                            
				keycons();
				return riotRead[SWCHB];

			case TIM1T:
			case TIM8T:
			case TIM64T:
			case T1024T:
				return do_timer(clkcount);
			default:
				return 65;
		}
	}
	return res;
}
